### Loading组件

#### 相关知识点
* CSS3
* SVG
* Canvas

#### 组件内容
Loading组件包含两个子组件,等待Loading和成功Loading, 目前不推荐自行配置

#### 如何使用
npm
```shell
## 未安装package
npm install hello-ui --save-dev
## 已安装package
npm update hello-ui --save-dev
```
html
```html
<!-- 成功Loading才需要DOM支持,需初始化该DOM的宽高 -->
<div class="bx-loading" style="width: 50px;height: 50px"></div>
```
import as module
```js
import 'node_modules/hello-ui/dist/components/Loading/Loading.css';
import {Loading} from 'hello-ui';
Loading.show(); // 显示等待加载动画
Loading.hide(); // 隐藏等待加载动画
var loading = Loading.success('.bx-loading');
loading.start(); // 动画初始化并开始运行,显示等待Loading
loading.success(); // 动画状态变更,显示成功动画
```

### API
暂无

### Example
[功能预览](https://qiuguorong.github.io/hello-ui/dist/#/loading)
[具体实现](https://github.com/qiuguorong/hello-ui/blob/master/src/views/Loading.vue)

### 设备兼容
暂无

### 其它说明
等待Loading组件在IOS系统内采用canvas动画，在Android内采用css3动画，在Android 4.3.0及以下做了降级处理<br />
该组件针对flexible方案，做了兼容处理。<br />
如IOS系统中，若initial-scale=0.5时，loading组件会放大2倍<br />
Android系统中，因initial-scale表现各个设备存在差异，因此没办法兼容，默认initial-scale=1<br />
